//Author: George Koutsogiannakis
//Intellectual Property of George Koutsogiannakis
//CEO and President of Neuroweb Technologies.
//Copying or unauthorized usage of this product is prohibeted without the consent of the author
////Copying and usage for any other reason other than educational 
//is prohibited without the author's explicit authorization in writing.

package com.neuroweb.george.main.retirement.amortization.utilities;
import java.text.DecimalFormat;
import java.awt.Graphics;
import java.awt.Graphics2D;
import javax.swing.JComponent;
import java.awt.geom.*;
import java.util.*;
import java.awt.Color;
import javax.swing.*;
import java.awt.*;
public class createGraph extends JComponent
{
	final static BasicStroke stroke = new BasicStroke(1.0f);
	
	final static float dash1[] = {10.0f};
	final static BasicStroke dashed = new BasicStroke(1.0f, 
                                                      BasicStroke.CAP_BUTT, 
                                                      BasicStroke.JOIN_MITER, 
                                                      10.0f, dash1, 0.0f);
	int point1x, point1y,pixelsx,pixelsy;
	int timer;
	double markx, markxformatted, marky;
	static int maxx=600, maxy=400, n=20;
	//Vector vectrx=new Vector(50,50);
	Vector vectory1=new Vector(50,50);
	String graphname;
	//x1,y1 represents the origin of the graph
	DecimalFormat onedigit = new DecimalFormat("0.0");
	Color firstcolor;
	Color secondcolor;
	public createGraph(String title, int x1, int y1, int periods, Vector vectory, Color color1, Color color2)
	{
		
		
		for (int g1=0; g1<=vectory.size()-1; g1++)
		{
		
			Object value1=vectory.elementAt(g1);
			vectory1.addElement(value1);
		}
		//vectory1=vectory;
		
		//vectory1.trimToSize();
		point1x=x1;
		
		point1y=y1;
		
		timer=periods;
		
		graphname=title;
		markx= timer/20.0;
       
		
		marky= findMax(vectory1)/20.0;
		//pixels per interval marked on the axis
		pixelsx=maxx/n;
		pixelsy=maxy/n;
		firstcolor=color1;
		secondcolor=color2;
		System.out.println("markx="+markx);
	}
	
	public void paintComponent(Graphics g)
	{
		
		Graphics2D g2=(Graphics2D) g;
		g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
		Ellipse2D.Double ellipse=new Ellipse2D.Double(0,0, 970, 670);
		g2.setPaint(new GradientPaint(0,0,firstcolor,970,670,secondcolor,true));
		
		g2.fill(ellipse);
		g2.draw(ellipse);
		drawAxis(g2);	
	}
	
	
	public void drawAxis(Graphics2D g2)
	{
		
		//vectory1.setSize(timer);
		System.out.println("i am drawing the axis"+point1x+" "+point1y);
		Point2D.Double origin =new Point2D.Double(point1x, point1y);
		Point2D.Double endx=new Point2D.Double((point1x+maxx+10), point1y);
		Point2D.Double endy=new Point2D.Double(point1x, (point1y-maxy-10));
		Line2D.Double xaxis=new Line2D.Double(origin, endx);
		Line2D.Double yaxis=new Line2D.Double(origin, endy);
		g2.setPaint(Color.red);
		g2.draw(xaxis);
		g2.draw(yaxis);
		//draw markers on the axis
		//marker value
		double markxvalue;
		double markyvalue;
		//x-axis
		for (int j=1; j<=n; j++)
		{
			g2.setPaint(Color.black);
			Line2D.Double markerx=new Line2D.Double(point1x+j*maxx/n, point1y, point1x+j*maxx/n, point1y+5);
			g2.draw(markerx);

			//now print the value of each marker in the x -direction 
			if(markx<=10)
			{
				
				markxvalue=markx*j;
				String markxformatted=onedigit.format(markxvalue);
				g2.drawString(markxformatted, point1x-10+j*maxx/n, point1y+25);
			}
			//for number of periods greater than 10 use integer values rather than double values.
			else
			{
				int markxint=(int)markx;
				int markxvalueint=markxint*j;
				Integer markxvalueintobject=(Integer)markxvalueint;
				String markxformatted1=markxvalueintobject.toString();
				g2.drawString(markxformatted1, point1x-10+j*maxx/n, point1y+25);
			}
			g2.setPaint(Color.black);
			
		}
		//y-axis markers
		for (int j=1; j<=n; j++)
		{
			g2.setPaint(Color.black);
			Line2D.Double markery=new Line2D.Double(point1x, point1y-j*maxy/n, point1x-5, point1y-j*maxy/n);
			g2.draw(markery);

			//now print the value of each marker in the y-direction
			//remember that marky is the maximum value on the y-axix divided by the number of markers(20)
			markyvalue=marky*j;
			String markyformatted=onedigit.format(markyvalue);
			g2.setPaint(Color.black);
			g2.drawString(markyformatted, point1x-70, point1y+5-j*maxy/n);
			
		}
		g2.setPaint(Color.black);
		g2.drawString("Time Periods", point1x+maxx*(n-4)/n, point1y+50);
		//draw the graph 's y-axis parameter name.
		g2.drawString(graphname, point1x-80, point1y-maxy-20);
		//CLOSE THE GRAPH WITH TWO MORE BORDERS
		g2.setPaint(Color.red);
		Line2D.Double northborder=new Line2D.Double(point1x, point1y-maxy-10, point1x+maxx+10, point1y-maxy-10);
		g2.draw(northborder);
		Line2D.Double eastborder=new Line2D.Double(point1x+maxx+10, point1y-maxy-10, point1x+maxx+10, point1y);
		g2.draw(eastborder);
		g2.setPaint(Color.blue);
		drawGraph(g2);
		
	
	}
	
	public double findMax(Vector vector)
	{
		double maximum=0;
		for(int k=0; k<=vector.size()-1; k++)
		{
			
			/*	
			Object first=vector.elementAt(k);
			Object second=vector.elementAt(k+1);
			double firstd=(Double)first;
			double secondd=(Double)second;
			maximum=Math.max(firstd, secondd);*/
			Object first=vector.elementAt(k);
			double firstd=(Double)first;
			maximum=Math.max(maximum, firstd);
		}
		System.out.println("The maximum value is"+maximum);
		return maximum;
	}
	
	public void drawGraph(Graphics2D g2)
	{
		int l=0;
		int periodn=1;
		System.out.println("Size of vectory1="+vectory1.size());
		System.out.println("The value of timer is="+timer);
		for (l=0; l<=timer-2; l++)
		{
		    
				double x=point1x+(periodn/markx)*pixelsx;
				Object value=vectory1.elementAt(l);
				double valuey=(Double)value;
				if(valuey<=0)
				{
					g2.setPaint(Color.red);
					g2.drawString("YOU HAVE EXCEEDED THE AVAILABLE MONEY AT PERIOD"+" "+(l+1), point1x+100, point1y+60);
					break;
				}
				double y=point1y-(valuey/marky)*pixelsy;
				Point2D.Double r1 =new Point2D.Double(x, y);
				periodn++;
				double x1=point1x+(periodn/markx)*pixelsx;
				Object newvalue=vectory1.elementAt(l+1);
				double newvaluey=(Double)newvalue;
				double y1=point1y-(newvaluey/marky)*pixelsy;	
				Point2D.Double r2 =new Point2D.Double(x1, y1);
				Line2D.Double line=new Line2D.Double(r1,r2);
				g2.setStroke(stroke);
				g2.draw(line);
				
				//create dashed lines
				if (periodn==(timer+2)/2)
				{
					Point2D.Double r3=new Point2D.Double(x, point1y);
					Point2D.Double r4=new Point2D.Double(x,y);
					g2.setStroke(dashed);
					
					Line2D.Double dashedline=new Line2D.Double(r3,r4);
					g2.draw(dashedline);
					Point2D.Double r5=new Point.Double(point1x, y);
					Line2D.Double dashedline1=new Line2D.Double(r4, r5);
					g2.draw(dashedline1);
					int xint=(int)x;
					g2.drawString("Amount at half the time periods", xint+10, point1y-60);
				
			
				}//end of if structure

			

		}//end of for loop
		
	
	}//end of method drawGraph



}//end of createGraph class
